ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.5 by greg, Thu Dec 9 17:00:43 2010 UTC vs.
Revision 2.25 by greg, Wed Aug 24 04:14:58 2011 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 < my $nsamp = 1000;
16 > my @savedARGV = @ARGV;
17 > my $tensortree = 0;
18 > my $ttlog2 = 4;
19 > my $nsamp = 2000;
20 > my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24 + my $doforw = 0;
25 + my $doback = 1;
26 + my $gunit = "Meter";
27   my @dim;
28   # Get options
29   while ($#ARGV >= 0) {
30          if ("$ARGV[0]" =~ /^[-+]m/) {
31                  $mgfin = ("$ARGV[0]" =~ /^\+/);
32 +        } elsif ("$ARGV[0]" eq "-r") {
33 +                $rtargs = "$rtargs $ARGV[1]";
34 +                shift @ARGV;
35          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
36                  $geout = ("$ARGV[0]" =~ /^\+/);
37 +                $gunit = $ARGV[1];
38 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
39 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
40 +                }
41 +                shift @ARGV;
42 +        } elsif ("$ARGV[0]" =~ /^[-+]f/) {
43 +                $doforw = ("$ARGV[0]" =~ /^\+/);
44 +        } elsif ("$ARGV[0]" =~ /^[-+]b/) {
45 +                $doback = ("$ARGV[0]" =~ /^\+/);
46 +        } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
47 +                $tensortree = substr($ARGV[0], 2, 1);
48 +                $ttlog2 = $ARGV[1];
49 +                shift @ARGV;
50          } elsif ("$ARGV[0]" eq "-c") {
51                  $nsamp = $ARGV[1];
52                  shift @ARGV;
# Line 31 | Line 55 | while ($#ARGV >= 0) {
55                  shift @ARGV;
56          } elsif ("$ARGV[0]" =~ /^-d/) {
57                  userror() if ($#ARGV < 6);
58 <                @dim = "@ARGV[1..6]";
58 >                @dim = @ARGV[1..6];
59                  shift @ARGV for (1..6);
60          } elsif ("$ARGV[0]" =~ /^[-+]./) {
61                  userror();
# Line 40 | Line 64 | while ($#ARGV >= 0) {
64          }
65          shift @ARGV;
66   }
67 + # Check that we're actually being asked to do something
68 + die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
69 + # Name our own persist file?
70 + my $persistfile;
71 + if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
72 +        $persistfile = "$td/pfile.txt";
73 +        $rtargs = "-PP $persistfile $rtargs";
74 + }
75   # Get scene description and dimensions
76   my $radscn = "$td/device.rad";
77   my $mgfscn = "$td/device.mgf";
# Line 49 | Line 81 | if ( $mgfin ) {
81          die "Could not load MGF input\n" if ( $? );
82          system "mgf2rad $mgfscn > $radscn";
83   } else {
84 <        system "cat @ARGV | xform -e > $radscn";
84 >        system "xform -e @ARGV > $radscn";
85          die "Could not load Radiance input\n" if ( $? );
86          system "rad2mgf $radscn > $mgfscn" if ( $geout );
87   }
88   if ($#dim != 5) {
89 <        @dim = split /\s+/, `getbbox -h $radscn`;
58 <        shift @dim;
89 >        @dim = split ' ', `getbbox -h $radscn`;
90   }
91   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
92 < # Add receiver surface (rectangle)
93 < my $modnm="_receiver_black_";
92 > # Add receiver surfaces (rectangular)
93 > my $fmodnm="receiver_face";
94 > my $bmodnm="receiver_behind";
95   open(RADSCN, ">> $radscn");
96 < print RADSCN "void glow $modnm\n0\n0\n4 0 0 0 0\n\n";
97 < print RADSCN "$modnm polygon _receiver_\n0\n0\n12\n";
98 < print RADSCN "\t",$dim[0],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
99 < print RADSCN "\t",$dim[0],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
68 < print RADSCN "\t",$dim[1],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
69 < print RADSCN "\t",$dim[1],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
96 > print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
97 > print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
98 > print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
99 > print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
100   close RADSCN;
101   # Generate octree
102   system "oconv -w $radscn > $octree";
103   die "Could not compile scene\n" if ( $? );
104 < # Set up sampling
104 > # Output XML prologue
105 > print
106 > '<?xml version="1.0" encoding="UTF-8"?>
107 > <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
108 > ';
109 > print "<!-- File produced by: genBSDF @savedARGV -->\n";
110 > print
111 > '<WindowElementType>System</WindowElementType>
112 > <Optical>
113 > <Layer>
114 >        <Material>
115 >                <Name>Name</Name>
116 >                <Manufacturer>Manufacturer</Manufacturer>
117 > ';
118 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 > print "\t\t<DeviceType>Integral</DeviceType>\n";
122 > # Output MGF description if requested
123 > if ( $geout ) {
124 >        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
125 >        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
126 >        open(MGFSCN, "< $mgfscn");
127 >        while (<MGFSCN>) { print $_; }
128 >        close MGFSCN;
129 >        print "xf\n";
130 >        print "\t\t</Geometry>\n";
131 > }
132 > print " </Material>\n";
133 > # Set up surface sampling
134 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
135 > my $ny = int($nsamp/$nx + .5);
136 > $nsamp = $nx * $ny;
137 > my $ns = 2**$ttlog2;
138 > my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
139 > # Create data segments (all the work happens here)
140 > if ( $tensortree ) {
141 >        do_tree_bsdf();
142 > } else {
143 >        do_matrix_bsdf();
144 > }
145 > # Output XML epilogue
146 > print
147 > '</Layer>
148 > </Optical>
149 > </WindowElement>
150 > ';
151 > # Clean up temporary files and exit
152 > if ( $persistfile && open(PFI, "< $persistfile") ) {
153 >        while (<PFI>) {
154 >                s/^[^ ]* //;
155 >                kill('ALRM', $_);
156 >                last;
157 >        }
158 >        close PFI;
159 > }
160 > exec("rm -rf $td");
161 >
162 > #-------------- End of main program segment --------------#
163 >
164 > #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
165 > sub do_tree_bsdf {
166 > # Get sampling rate and subdivide task
167 > my $ns2 = $ns;
168 > $ns2 /= 2 if ( $tensortree == 3 );
169 > my $nsplice = $nproc;
170 > $nsplice *= 10 if ($nproc > 1);
171 > $nsplice = $ns2 if ($nsplice > $ns2);
172 > $nsplice = 999 if ($nsplice > 999);
173 > @pdiv = (0, int($ns2/$nsplice));
174 > my $nrem = $ns2 % $nsplice;
175 > for (my $i = 1; $i < $nsplice; $i++) {
176 >        my $nv = $pdiv[$i] + $pdiv[1];
177 >        ++$nv if ( $nrem-- > 0 );
178 >        push @pdiv, $nv;
179 > }
180 > die "Script error 1" if ($pdiv[-1] != $ns2);
181 > # Shirley-Chiu mapping from unit square to disk
182 > $sq2disk = '
183 > in_square_a = 2*in_square_x - 1;
184 > in_square_b = 2*in_square_y - 1;
185 > in_square_rgn = if(in_square_a + in_square_b,
186 >                        if(in_square_a - in_square_b, 1, 2),
187 >                        if(in_square_b - in_square_a, 3, 4));
188 > out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
189 >                        -in_square_a, -in_square_b);
190 > out_disk_phi = PI/4 * select(in_square_rgn,
191 >                                in_square_b/in_square_a,
192 >                                2 - in_square_a/in_square_b,
193 >                                4 + in_square_b/in_square_a,
194 >                                if(in_square_b*in_square_b,
195 >                                        6 - in_square_a/in_square_b, 0));
196 > Dx = out_disk_r*cos(out_disk_phi);
197 > Dy = out_disk_r*sin(out_disk_phi);
198 > Dz = sqrt(1 - out_disk_r*out_disk_r);
199 > ';
200 > # Shirley-Chiu mapping from unit disk to square
201 > $disk2sq = '
202 > norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
203 > in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
204 > in_disk_phi = norm_radians(atan2(Dy, Dx));
205 > in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
206 > out_square_a = select(in_disk_rgn,
207 >                        in_disk_r,
208 >                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
209 >                        -in_disk_r,
210 >                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
211 > out_square_b = select(in_disk_rgn,
212 >                        in_disk_phi*in_disk_r/(PI/4),
213 >                        in_disk_r,
214 >                        (PI - in_disk_phi)*in_disk_r/(PI/4),
215 >                        -in_disk_r);
216 > out_square_x = (out_square_a + 1)/2;
217 > out_square_y = (out_square_b + 1)/2;
218 > ';
219 > # Announce ourselves in XML output
220 > print "\t<DataDefinition>\n";
221 > print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
222 > print "\t</DataDefinition>\n";
223 > # Fork parallel rtcontrib processes to compute each side
224 > my $npleft = $nproc;
225 > if ( $doback ) {
226 >        for (my $splice = 0; $splice < $nsplice; $splice++) {
227 >                if (! $npleft ) {
228 >                        wait();
229 >                        die "rtcontrib process reported error" if ( $? );
230 >                        $npleft++;
231 >                }
232 >                bg_tree_rtcontrib(0, $splice);
233 >                $npleft--;
234 >        }
235 >        while (wait() >= 0) {
236 >                die "rtcontrib process reported error" if ( $? );
237 >                $npleft++;
238 >        }
239 >        ttree_out(0);
240 > }
241 > if ( $doforw ) {
242 >        for (my $splice = 0; $splice < $nsplice; $splice++) {
243 >                if (! $npleft ) {
244 >                        wait();
245 >                        die "rtcontrib process reported error" if ( $? );
246 >                        $npleft++;
247 >                }
248 >                bg_tree_rtcontrib(1, $splice);
249 >                $npleft--;
250 >        }
251 >        while (wait() >= 0) {
252 >                die "rtcontrib process reported error" if ( $? );
253 >                $npleft++;
254 >        }
255 >        ttree_out(1);
256 > }
257 > }       # end of sub do_tree_bsdf()
258 >
259 > # Run rtcontrib process in background to generate tensor tree samples
260 > sub bg_tree_rtcontrib {
261 >        my $pid = fork();
262 >        die "Cannot fork new process" unless defined $pid;
263 >        if ($pid > 0) { return $pid; }
264 >        my $forw = shift;
265 >        my $pn = shift;
266 >        my $pbeg = $pdiv[$pn];
267 >        my $plen = $pdiv[$pn+1] - $pbeg;
268 >        my $matargs = "-m $bmodnm";
269 >        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
270 >        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
271 >                "-e '$disk2sq' -bn '$ns*$ns' " .
272 >                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
273 >                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
274 >        if ( $tensortree == 3 ) {
275 >                # Isotropic BSDF
276 >                $cmd = "cnt $plen $ny $nx " .
277 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
278 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
279 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
280 >                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
281 >                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
282 >                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
283 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
284 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
285 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
286 >                        "| $cmd";
287 >        } else {
288 >                # Anisotropic BSDF
289 >                # Sample area vertically to improve load balance, since
290 >                # shading systems usually have bilateral symmetry (L-R)
291 >                $cmd = "cnt $plen $ns $ny $nx " .
292 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
293 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
294 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
295 >                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
296 >                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
297 >                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
298 >                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
299 >                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
300 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
301 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
302 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
303 >                        "| $cmd";
304 >        }
305 > # print STDERR "Starting: $cmd\n";
306 >        exec($cmd);             # no return; status report to parent via wait
307 >        die "Cannot exec: $cmd\n";
308 > }       # end of bg_tree_rtcontrib()
309 >
310 > # Simplify and output tensor tree results
311 > sub ttree_out {
312 >        my $forw = shift;
313 >        my $side = ("Back","Front")[$forw];
314 > # Only output one transmitted distribution, preferring backwards
315 > if ( !$forw || !$doback ) {
316 > print
317 > '       <WavelengthData>
318 >                <LayerNumber>System</LayerNumber>
319 >                <Wavelength unit="Integral">Visible</Wavelength>
320 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
321 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
322 >                <WavelengthDataBlock>
323 >                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
324 >                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
325 >                        <ScatteringDataType>BTDF</ScatteringDataType>
326 >                        <ScatteringData>
327 > ';
328 > system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
329 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
330 >        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
331 >        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
332 > die "Failure running rttree_reduce" if ( $? );
333 > print
334 > '                       </ScatteringData>
335 >                </WavelengthDataBlock>
336 >        </WavelengthData>
337 > ';
338 > }
339 > # Output reflection
340 > print
341 > '       <WavelengthData>
342 >                <LayerNumber>System</LayerNumber>
343 >                <Wavelength unit="Integral">Visible</Wavelength>
344 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
345 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
346 >                <WavelengthDataBlock>
347 > ';
348 > print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
349 > print
350 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
351 >                        <ScatteringDataType>BRDF</ScatteringDataType>
352 >                        <ScatteringData>
353 > ';
354 > system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
355 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
356 >        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
357 >        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
358 > die "Failure running rttree_reduce" if ( $? );
359 > print
360 > '                       </ScatteringData>
361 >                </WavelengthDataBlock>
362 >        </WavelengthData>
363 > ';
364 > }       # end of ttree_out()
365 >
366 > #------------- End of do_tree_bsdf() & subroutines -------------#
367 >
368 > #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
369 > sub do_matrix_bsdf {
370 > # Set up sampling of portal
371   # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
372 < my $tcal = '
372 > $tcal = '
373   DEGREE : PI/180;
374   sq(x) : x*x;
375   Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
# Line 86 | Line 382 | Kcol = Kbin - Kaccum(Krow-1);
382   Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
383   Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
384   sin_kpol = sin(Kpol);
385 < Dx = -cos(Kazi)*sin_kpol;
385 > Dx = cos(Kazi)*sin_kpol;
386   Dy = sin(Kazi)*sin_kpol;
387   Dz = sqrt(1 - sin_kpol*sin_kpol);
388   KprojOmega = PI * if(Kbin-.5,
389          (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
390          1 - sq(cos(Kpola(1)*DEGREE)));
391   ';
392 < # Compute Klems bin from exiting ray direction
393 < my $kcal = '
392 > # Compute Klems bin from exiting ray direction (forward or backward)
393 > $kcal = '
394   DEGREE : PI/180;
395 + abs(x) : if(x, x, -x);
396   Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
397   posangle(a) : if(-a, a + 2*PI, a);
398   Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
# Line 116 | Line 413 | kbin2(pol,azi) = select(kfindrow(1, pol),
413                  kaccum(7) + kazn(azi,360/knaz(8)),
414                  kaccum(8) + kazn(azi,360/knaz(9))
415          );
416 < kbin = kbin2(Acos(Dz), Atan2(Dy, -Dx));
416 > kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
417   ';
418   my $ndiv = 145;
122 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
123 my $ny = int($nsamp/$nx + .5);
124 $nsamp = $nx * $ny;
419   # Compute scattering data using rtcontrib
420 < my $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
420 > my @tfarr;
421 > my @rfarr;
422 > my @tbarr;
423 > my @rbarr;
424 > my $cmd;
425 > my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
426 >        "-e '$kcal' -b kbin -bn $ndiv " .
427 >        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
428 > my $rccmd = "rcalc -e '$tcal' " .
429 >        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
430 >        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
431 >        q[-o '${  oval  },'];
432 > if ( $doforw ) {
433 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
434 >        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
435 >        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
436 >        "-e 'zp:$dim[4]' " .
437 >        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
438 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
439 >        "| $rtcmd";
440 > system "$cmd" || die "Failure running: $cmd\n";
441 > @tfarr = `$rccmd $td/$fmodnm.flt`;
442 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
443 > @rfarr = `$rccmd $td/$bmodnm.flt`;
444 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
445 > }
446 > if ( $doback ) {
447 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
448          "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
449          "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
450 <        "-e 'zp:$dim[4]-1e-5' " .
450 >        "-e 'zp:$dim[5]' " .
451          q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
452 <        q{-e '$1=xp;$2=yp;$3=zp;$4=Dx;$5=Dy;$6=Dz' } .
453 <        "| rtcontrib -h -ff -n $nproc -c $nsamp -e '$kcal' -b kbin -bn $ndiv " .
454 <        "-m $modnm -w -ab 5 -ad 700 -lw 3e-6 $octree " .
455 <        "| rcalc -e '$tcal' " .
456 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-1,$ndiv)' " .
457 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
458 < my @darr = `$cmd`;
138 < die "Failure running: $cmd\n" if ( $? );
139 < # Output XML prologue
140 < print
141 < '<?xml version="1.0" encoding="UTF-8"?>
142 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
143 <        <WindowElementType>System</WindowElementType>
144 <        <Optical>
145 <                <Layer>
146 <                <Material>
147 <                        <Name>Name</Name>
148 <                        <Manufacturer>Manufacturer</Manufacturer>
149 < ';
150 < printf "\t\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
151 < printf "\t\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
152 < printf "\t\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
153 < print "\t\t\t<DeviceType>Integral</DeviceType>\n";
154 < # Output MGF description if requested
155 < if ( $geout ) {
156 <        print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
157 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
158 <        system "cat $mgfscn";
159 <        print "xf\n";
160 <        print "\t\t\t</Geometry>\n";
452 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
453 >        "| $rtcmd";
454 > system "$cmd" || die "Failure running: $cmd\n";
455 > @tbarr = `$rccmd $td/$bmodnm.flt`;
456 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
457 > @rbarr = `$rccmd $td/$fmodnm.flt`;
458 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
459   }
460 < print '                 </Material>
461 <                <DataDefinition>
462 <                        <IncidentDataStructure>Columns</IncidentDataStructure>
463 <                        <AngleBasis>
460 > # Output angle basis
461 > print
462 > '       <DataDefinition>
463 >                <IncidentDataStructure>Columns</IncidentDataStructure>
464 >                <AngleBasis>
465                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
466 <                                <AngleBasisBlock>
466 >                        <AngleBasisBlock>
467                                  <Theta>0</Theta>
468                                  <nPhis>1</nPhis>
469                                  <ThetaBounds>
470 <                                <LowerTheta>0</LowerTheta>
471 <                                <UpperTheta>5</UpperTheta>
470 >                                        <LowerTheta>0</LowerTheta>
471 >                                        <UpperTheta>5</UpperTheta>
472                                  </ThetaBounds>
473                                  </AngleBasisBlock>
474                                  <AngleBasisBlock>
# Line 238 | Line 537 | print '                        </Material>
537                          </AngleBasisBlock>
538                  </AngleBasis>
539          </DataDefinition>
540 <        <WavelengthData>
540 > ';
541 > if ( $doforw ) {
542 > print
543 > '       <WavelengthData>
544                  <LayerNumber>System</LayerNumber>
545                  <Wavelength unit="Integral">Visible</Wavelength>
546                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 250 | Line 552 | print '                        </Material>
552                          <ScatteringDataType>BTDF</ScatteringDataType>
553                          <ScatteringData>
554   ';
555 < # Output computed data (transposed order)
555 > # Output front transmission (transposed order)
556   for (my $od = 0; $od < $ndiv; $od++) {
557          for (my $id = 0; $id < $ndiv; $id++) {
558 <                print $darr[$ndiv*$id + $od];
558 >                print $tfarr[$ndiv*$id + $od];
559          }
560          print "\n";
561   }
260 # Output XML epilogue
562   print
563 < '               </ScatteringData>
564 <        </WavelengthDataBlock>
563 > '                       </ScatteringData>
564 >                </WavelengthDataBlock>
565          </WavelengthData>
566 < </Layer>
567 < </Optical>
568 < </WindowElement>
566 >        <WavelengthData>
567 >                <LayerNumber>System</LayerNumber>
568 >                <Wavelength unit="Integral">Visible</Wavelength>
569 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
570 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
571 >                <WavelengthDataBlock>
572 >                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
573 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
574 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
575 >                        <ScatteringDataType>BRDF</ScatteringDataType>
576 >                        <ScatteringData>
577   ';
578 < # Clean up temporary files
579 < system "rm -rf $td";
578 > # Output front reflection (transposed order)
579 > for (my $od = 0; $od < $ndiv; $od++) {
580 >        for (my $id = 0; $id < $ndiv; $id++) {
581 >                print $rfarr[$ndiv*$id + $od];
582 >        }
583 >        print "\n";
584 > }
585 > print
586 > '                       </ScatteringData>
587 >                </WavelengthDataBlock>
588 >        </WavelengthData>
589 > ';
590 > }
591 > if ( $doback ) {
592 > print
593 > '       <WavelengthData>
594 >                <LayerNumber>System</LayerNumber>
595 >                <Wavelength unit="Integral">Visible</Wavelength>
596 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
597 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
598 >                <WavelengthDataBlock>
599 >                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
600 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
601 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
602 >                        <ScatteringDataType>BTDF</ScatteringDataType>
603 >                        <ScatteringData>
604 > ';
605 > # Output back transmission (transposed order)
606 > for (my $od = 0; $od < $ndiv; $od++) {
607 >        for (my $id = 0; $id < $ndiv; $id++) {
608 >                print $tbarr[$ndiv*$id + $od];
609 >        }
610 >        print "\n";
611 > }
612 > print
613 > '                       </ScatteringData>
614 >                </WavelengthDataBlock>
615 >        </WavelengthData>
616 >        <WavelengthData>
617 >                <LayerNumber>System</LayerNumber>
618 >                <Wavelength unit="Integral">Visible</Wavelength>
619 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
620 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
621 >                <WavelengthDataBlock>
622 >                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
623 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
624 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
625 >                        <ScatteringDataType>BRDF</ScatteringDataType>
626 >                        <ScatteringData>
627 > ';
628 > # Output back reflection (transposed order)
629 > for (my $od = 0; $od < $ndiv; $od++) {
630 >        for (my $id = 0; $id < $ndiv; $id++) {
631 >                print $rbarr[$ndiv*$id + $od];
632 >        }
633 >        print "\n";
634 > }
635 > print
636 > '                       </ScatteringData>
637 >                </WavelengthDataBlock>
638 >        </WavelengthData>
639 > ';
640 > }
641 > }
642 > #------------- End of do_matrix_bsdf() --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines